Index: /trunk/Softwares/Basic_test/src/c/dhry21a.c
===================================================================
--- /trunk/Softwares/Basic_test/src/c/dhry21a.c	(revision 88)
+++ /trunk/Softwares/Basic_test/src/c/dhry21a.c	(revision 88)
@@ -0,0 +1,398 @@
+/*
+ *************************************************************************
+ *
+ *                   "DHRYSTONE" Benchmark Program
+ *                   -----------------------------
+ *
+ *  Version:    C, Version 2.1
+ *
+ *  File:       dhry_1.c (part 2 of 3)
+ *
+ *  Date:       May 25, 1988
+ *
+ *  Author:     Reinhold P. Weicker
+ *
+ *************************************************************************
+ */
+
+#include <stdio.h>
+#include <string.h>
+#include <stdlib.h>
+#include "dhry.h"
+#include "dhry21.h"
+
+/* Global Variables: */
+
+Rec_Pointer     Ptr_Glob,
+                Next_Ptr_Glob;
+int             Int_Glob;
+Boolean         Bool_Glob;
+char            Ch_1_Glob,
+                Ch_2_Glob;
+int             Arr_1_Glob [50];
+int             Arr_2_Glob [50] [50];
+
+char Reg_Define[] = "Register option selected.";
+
+//extern char     *malloc ();
+//Enumeration     Func_1 ();
+  /* 
+  forward declaration necessary since Enumeration may not simply be int
+  */
+
+#ifndef ROPT
+#define REG
+        /* REG becomes defined as empty */
+        /* i.e. no register variables   */
+#else
+#define REG register
+#endif
+
+
+/* variables for time measurement: */
+
+#define Too_Small_Time 2
+                /* Measurements should last at least 2 seconds */
+
+DOUBLE          Begin_Time,
+                End_Time,
+                User_Time;
+
+DOUBLE          Microseconds,
+                Dhrystones_Per_Second,
+                Vax_Mips;
+
+/* end of variables for time measurement */
+
+int main_dhry21 (unsigned int NUMBER_OF_RUNS)
+/*****/
+
+  /* main program, corresponds to procedures        */
+  /* Main and Proc_0 in the Ada version             */
+{
+  DOUBLE   dtime();
+
+        One_Fifty       Int_1_Loc;
+  REG   One_Fifty       Int_2_Loc;
+        One_Fifty       Int_3_Loc;
+  REG   char            Ch_Index;
+        Enumeration     Enum_Loc;
+        Str_30          Str_1_Loc;
+        Str_30          Str_2_Loc;
+  REG   int             Run_Index;
+  REG   int             Number_Of_Runs;
+
+        FILE            *Ap;
+
+  /* Initializations */
+
+  if ((Ap = fopen("dhry.res","a+")) == NULL)
+    {
+       printf("Can not open dhry.res\n\n");
+       exit(1);
+    }
+
+  Next_Ptr_Glob = (Rec_Pointer) malloc (sizeof (Rec_Type));
+  Ptr_Glob      = (Rec_Pointer) malloc (sizeof (Rec_Type));
+
+  Ptr_Glob->Ptr_Comp                    = Next_Ptr_Glob;
+  Ptr_Glob->Discr                       = Ident_1;
+  Ptr_Glob->variant.var_1.Enum_Comp     = Ident_3;
+  Ptr_Glob->variant.var_1.Int_Comp      = 40;
+  strcpy (Ptr_Glob->variant.var_1.Str_Comp, 
+          "DHRYSTONE PROGRAM, SOME STRING");
+  strcpy (Str_1_Loc, "DHRYSTONE PROGRAM, 1'ST STRING");
+
+  Arr_2_Glob [8][7] = 10;
+        /* Was missing in published program. Without this statement,    */
+        /* Arr_2_Glob [8][7] would have an undefined value.             */
+        /* Warning: With 16-Bit processors and Number_Of_Runs > 32000,  */
+        /* overflow may occur for this array element.                   */
+
+  printf ("\n");
+  printf ("Dhrystone Benchmark, Version 2.1 (Language: C)\n");
+  printf ("\n");
+
+  /*
+  if (Reg)
+  {
+    printf ("Program compiled with 'register' attribute\n");
+    printf ("\n");
+  }
+  else
+  {
+    printf ("Program compiled without 'register' attribute\n");
+    printf ("\n");
+  }
+  */
+
+//**********************************************************************
+//  printf ("Please give the number of runs through the benchmark: ");
+//  {
+//    int n;
+//    scanf ("%d", &n);
+//    Number_Of_Runs = n;
+//  }
+//  printf ("\n");
+//**********************************************************************
+
+  Number_Of_Runs = NUMBER_OF_RUNS;
+  
+  printf ("Execution starts, %d runs through Dhrystone\n",Number_Of_Runs);
+
+  /***************/
+  /* Start timer */
+  /***************/
+ 
+  Begin_Time = dtime();
+  
+  for (Run_Index = 1; Run_Index <= Number_Of_Runs; ++Run_Index)
+  {
+
+    Proc_5();
+    Proc_4();
+      /* Ch_1_Glob == 'A', Ch_2_Glob == 'B', Bool_Glob == true */
+    Int_1_Loc = 2;
+    Int_2_Loc = 3;
+    strcpy (Str_2_Loc, "DHRYSTONE PROGRAM, 2'ND STRING");
+    Enum_Loc = Ident_2;
+    Bool_Glob = ! Func_2 (Str_1_Loc, Str_2_Loc);
+      /* Bool_Glob == 1 */
+    while (Int_1_Loc < Int_2_Loc)  /* loop body executed once */
+    {
+      Int_3_Loc = 5 * Int_1_Loc - Int_2_Loc;
+        /* Int_3_Loc == 7 */
+      Proc_7 (Int_1_Loc, Int_2_Loc, &Int_3_Loc);
+        /* Int_3_Loc == 7 */
+      Int_1_Loc += 1;
+    } /* while */
+      /* Int_1_Loc == 3, Int_2_Loc == 3, Int_3_Loc == 7 */
+    Proc_8 (Arr_1_Glob, Arr_2_Glob, Int_1_Loc, Int_3_Loc);
+      /* Int_Glob == 5 */
+    Proc_1 (Ptr_Glob);
+    for (Ch_Index = 'A'; Ch_Index <= Ch_2_Glob; ++Ch_Index)
+                             /* loop body executed twice */
+    {
+      if (Enum_Loc == Func_1 (Ch_Index, 'C'))
+          /* then, not executed */
+        {
+        Proc_6 (Ident_1, &Enum_Loc);
+        strcpy (Str_2_Loc, "DHRYSTONE PROGRAM, 3'RD STRING");
+        Int_2_Loc = Run_Index;
+        Int_Glob = Run_Index;
+        }
+    }
+      /* Int_1_Loc == 3, Int_2_Loc == 3, Int_3_Loc == 7 */
+    Int_2_Loc = Int_2_Loc * Int_1_Loc;
+    Int_1_Loc = Int_2_Loc / Int_3_Loc;
+    Int_2_Loc = 7 * (Int_2_Loc - Int_3_Loc) - Int_1_Loc;
+      /* Int_1_Loc == 1, Int_2_Loc == 13, Int_3_Loc == 7 */
+    Proc_2 (&Int_1_Loc);
+      /* Int_1_Loc == 5 */
+
+  } /* loop "for Run_Index" */
+
+  /**************/
+  /* Stop timer */
+  /**************/
+
+  End_Time = dtime();
+
+  printf ("Execution ends\n");
+  /*******************************************************************
+  printf ("\n");
+  printf ("Final values of the variables used in the benchmark:\n");
+  printf ("\n");
+  printf ("Int_Glob:            %d\n", Int_Glob);
+  printf ("        should be:   %d\n", 5);
+  printf ("Bool_Glob:           %d\n", Bool_Glob);
+  printf ("        should be:   %d\n", 1);
+  printf ("Ch_1_Glob:           %c\n", Ch_1_Glob);
+  printf ("        should be:   %c\n", 'A');
+  printf ("Ch_2_Glob:           %c\n", Ch_2_Glob);
+  printf ("        should be:   %c\n", 'B');
+  printf ("Arr_1_Glob[8]:       %d\n", Arr_1_Glob[8]);
+  printf ("        should be:   %d\n", 7);
+  printf ("Arr_2_Glob[8][7]:    %d\n", Arr_2_Glob[8][7]);
+  printf ("        should be:   Number_Of_Runs + 10\n");
+  printf ("Ptr_Glob->\n");
+  printf ("  Ptr_Comp:          %d\n", (int) Ptr_Glob->Ptr_Comp);
+  printf ("        should be:   (implementation-dependent)\n");
+  printf ("  Discr:             %d\n", Ptr_Glob->Discr);
+  printf ("        should be:   %d\n", 0);
+  printf ("  Enum_Comp:         %d\n", Ptr_Glob->variant.var_1.Enum_Comp);
+  printf ("        should be:   %d\n", 2);
+  printf ("  Int_Comp:          %d\n", Ptr_Glob->variant.var_1.Int_Comp);
+  printf ("        should be:   %d\n", 17);
+  printf ("  Str_Comp:          %s\n", Ptr_Glob->variant.var_1.Str_Comp);
+  printf ("        should be:   DHRYSTONE PROGRAM, SOME STRING\n");
+  printf ("Next_Ptr_Glob->\n");
+  printf ("  Ptr_Comp:          %d\n", (int) Next_Ptr_Glob->Ptr_Comp);
+  printf ("        should be:   (implementation-dependent), same as above\n");
+  printf ("  Discr:             %d\n", Next_Ptr_Glob->Discr);
+  printf ("        should be:   %d\n", 0);
+  printf ("  Enum_Comp:         %d\n", Next_Ptr_Glob->variant.var_1.Enum_Comp);
+  printf ("        should be:   %d\n", 1);
+  printf ("  Int_Comp:          %d\n", Next_Ptr_Glob->variant.var_1.Int_Comp);
+  printf ("        should be:   %d\n", 18);
+  printf ("  Str_Comp:          %s\n", Next_Ptr_Glob->variant.var_1.Str_Comp);
+  printf ("        should be:   DHRYSTONE PROGRAM, SOME STRING\n");
+  printf ("Int_1_Loc:           %d\n", Int_1_Loc);
+  printf ("        should be:   %d\n", 5);
+  printf ("Int_2_Loc:           %d\n", Int_2_Loc);
+  printf ("        should be:   %d\n", 13);
+  printf ("Int_3_Loc:           %d\n", Int_3_Loc);
+  printf ("        should be:   %d\n", 7);
+  printf ("Enum_Loc:            %d\n", Enum_Loc);
+  printf ("        should be:   %d\n", 1);
+  printf ("Str_1_Loc:           %s\n", Str_1_Loc);
+  printf ("        should be:   DHRYSTONE PROGRAM, 1'ST STRING\n");
+  printf ("Str_2_Loc:           %s\n", Str_2_Loc);
+  printf ("        should be:   DHRYSTONE PROGRAM, 2'ND STRING\n");
+  printf ("\n");
+  ********************************************************************/
+
+  User_Time = End_Time - Begin_Time;
+
+  if (User_Time < Too_Small_Time)
+  {
+    printf ("Measured time too small to obtain meaningful results : %f\n",User_Time);
+    printf ("Please increase number of runs\n");
+    printf ("\n");
+  }
+  else
+  {
+    Microseconds          = User_Time * Mic_secs_Per_Second / (DOUBLE) Number_Of_Runs;
+    Dhrystones_Per_Second = (DOUBLE) Number_Of_Runs / User_Time;
+    Vax_Mips              = Dhrystones_Per_Second / 1757.0;
+
+#ifdef ROPT
+    printf ("Register option selected?  YES\n");
+#else
+    printf ("Register option selected?  NO\n");
+    strcpy(Reg_Define, "Register option not selected.");
+#endif
+
+    printf ("Microseconds for one run through Dhrystone : %.1lf  \n",Microseconds);
+    printf ("Dhrystones per Second                      : %.1lf \n",Dhrystones_Per_Second);
+    printf ("VAX MIPS rating                            : %.3lf \n",Vax_Mips);
+    printf ("\n");
+  
+  fprintf(Ap,"\n");
+  fprintf(Ap,"Dhrystone Benchmark, Version 2.1 (Language: C)\n");
+  fprintf(Ap,"%s\n",Reg_Define);
+
+  fprintf(Ap,"Microseconds for one loop : %.1lf\n",Microseconds);
+  fprintf(Ap,"Dhrystones per second     : %.1lf\n",Dhrystones_Per_Second);
+  fprintf(Ap,"VAX MIPS rating           : %.3lf\n",Vax_Mips);
+  }
+  fclose(Ap);
+  return 0;
+  
+}
+
+void
+Proc_1 (Ptr_Val_Par)
+/******************/
+
+REG Rec_Pointer Ptr_Val_Par;
+    /* executed once */
+{
+  REG Rec_Pointer Next_Record = Ptr_Val_Par->Ptr_Comp;  
+                                        /* == Ptr_Glob_Next */
+  /* Local variable, initialized with Ptr_Val_Par->Ptr_Comp,    */
+  /* corresponds to "rename" in Ada, "with" in Pascal           */
+  
+  structassign (*Ptr_Val_Par->Ptr_Comp, *Ptr_Glob);
+  Ptr_Val_Par->variant.var_1.Int_Comp = 5;
+  Next_Record->variant.var_1.Int_Comp 
+        = Ptr_Val_Par->variant.var_1.Int_Comp;
+  Next_Record->Ptr_Comp = Ptr_Val_Par->Ptr_Comp;
+  Proc_3 (&Next_Record->Ptr_Comp);
+    /* Ptr_Val_Par->Ptr_Comp->Ptr_Comp 
+                        == Ptr_Glob->Ptr_Comp */
+  if (Next_Record->Discr == Ident_1)
+    /* then, executed */
+  {
+    Next_Record->variant.var_1.Int_Comp = 6;
+    Proc_6 (Ptr_Val_Par->variant.var_1.Enum_Comp, 
+           &Next_Record->variant.var_1.Enum_Comp);
+    Next_Record->Ptr_Comp = Ptr_Glob->Ptr_Comp;
+    Proc_7 (Next_Record->variant.var_1.Int_Comp, 10, 
+           &Next_Record->variant.var_1.Int_Comp);
+  }
+  else /* not executed */
+    structassign (*Ptr_Val_Par, *Ptr_Val_Par->Ptr_Comp);
+} /* Proc_1 */
+
+void
+Proc_2 (Int_Par_Ref)
+/******************/
+    /* executed once */
+    /* *Int_Par_Ref == 1, becomes 4 */
+
+One_Fifty   *Int_Par_Ref;
+{
+  One_Fifty  Int_Loc;
+  Enumeration   Enum_Loc;
+
+  Int_Loc = *Int_Par_Ref + 10;
+  do /* executed once */
+    if (Ch_1_Glob == 'A')
+      /* then, executed */
+    {
+      Int_Loc -= 1;
+      *Int_Par_Ref = Int_Loc - Int_Glob;
+      Enum_Loc = Ident_1;
+    } /* if */
+  while (Enum_Loc != Ident_1); /* true */
+} /* Proc_2 */
+
+void
+Proc_3 (Ptr_Ref_Par)
+/******************/
+    /* executed once */
+    /* Ptr_Ref_Par becomes Ptr_Glob */
+
+Rec_Pointer *Ptr_Ref_Par;
+
+{
+  if (Ptr_Glob != Null)
+    /* then, executed */
+    *Ptr_Ref_Par = Ptr_Glob->Ptr_Comp;
+  Proc_7 (10, Int_Glob, &Ptr_Glob->variant.var_1.Int_Comp);
+} /* Proc_3 */
+
+void
+Proc_4 () /* without parameters */
+/*******/
+    /* executed once */
+{
+  Boolean Bool_Loc;
+
+  Bool_Loc = Ch_1_Glob == 'A';
+  Bool_Glob = Bool_Loc | Bool_Glob;
+  Ch_2_Glob = 'B';
+} /* Proc_4 */
+
+void
+Proc_5 () /* without parameters */
+/*******/
+    /* executed once */
+{
+  Ch_1_Glob = 'A';
+  Bool_Glob = false;
+} /* Proc_5 */
+
+
+        /* Procedure for the assignment of structures,          */
+        /* if the C compiler doesn't support this feature       */
+#ifdef  NOSTRUCTASSIGN
+memcpy (d, s, l)
+register char   *d;
+register char   *s;
+register int    l;
+{
+        while (l--) *d++ = *s++;
+}
+#endif
Index: /trunk/Softwares/Basic_test/src/c/dhry21b.c
===================================================================
--- /trunk/Softwares/Basic_test/src/c/dhry21b.c	(revision 88)
+++ /trunk/Softwares/Basic_test/src/c/dhry21b.c	(revision 88)
@@ -0,0 +1,195 @@
+/*
+ *************************************************************************
+ *
+ *                   "DHRYSTONE" Benchmark Program
+ *                   -----------------------------
+ *
+ *  Version:    C, Version 2.1
+ *
+ *  File:       dhry_2.c (part 3 of 3)
+ *
+ *  Date:       May 25, 1988
+ *
+ *  Author:     Reinhold P. Weicker
+ *
+ *************************************************************************
+ */
+
+#include "dhry.h"
+#include "dhry21.h"
+#include <string.h>
+
+#ifndef REG
+#define REG
+        /* REG becomes defined as empty */
+        /* i.e. no register variables   */
+#else
+#define REG register
+#endif
+
+int     Int_Glob;
+char    Ch_1_Glob;
+
+void
+Proc_6 (Enum_Val_Par, Enum_Ref_Par)
+/*********************************/
+    /* executed once */
+    /* Enum_Val_Par == Ident_3, Enum_Ref_Par becomes Ident_2 */
+
+Enumeration  Enum_Val_Par;
+Enumeration *Enum_Ref_Par;
+{
+  *Enum_Ref_Par = Enum_Val_Par;
+  if (! Func_3 (Enum_Val_Par))
+    /* then, not executed */
+    *Enum_Ref_Par = Ident_4;
+  switch (Enum_Val_Par)
+  {
+    case Ident_1: 
+      *Enum_Ref_Par = Ident_1;
+      break;
+    case Ident_2: 
+      if (Int_Glob > 100)
+        /* then */
+      *Enum_Ref_Par = Ident_1;
+      else *Enum_Ref_Par = Ident_4;
+      break;
+    case Ident_3: /* executed */
+      *Enum_Ref_Par = Ident_2;
+      break;
+    case Ident_4: break;
+    case Ident_5: 
+      *Enum_Ref_Par = Ident_3;
+      break;
+  } /* switch */
+} /* Proc_6 */
+
+void
+Proc_7 (Int_1_Par_Val, Int_2_Par_Val, Int_Par_Ref)
+/**********************************************/
+    /* executed three times                                      */
+    /* first call:      Int_1_Par_Val == 2, Int_2_Par_Val == 3,  */
+    /*                  Int_Par_Ref becomes 7                    */
+    /* second call:     Int_1_Par_Val == 10, Int_2_Par_Val == 5, */
+    /*                  Int_Par_Ref becomes 17                   */
+    /* third call:      Int_1_Par_Val == 6, Int_2_Par_Val == 10, */
+    /*                  Int_Par_Ref becomes 18                   */
+One_Fifty       Int_1_Par_Val;
+One_Fifty       Int_2_Par_Val;
+One_Fifty      *Int_Par_Ref;
+{
+  One_Fifty Int_Loc;
+
+  Int_Loc = Int_1_Par_Val + 2;
+  *Int_Par_Ref = Int_2_Par_Val + Int_Loc;
+} /* Proc_7 */
+
+void
+Proc_8 (Arr_1_Par_Ref, Arr_2_Par_Ref, Int_1_Par_Val, Int_2_Par_Val)
+/*********************************************************************/
+    /* executed once      */
+    /* Int_Par_Val_1 == 3 */
+    /* Int_Par_Val_2 == 7 */
+Arr_1_Dim       Arr_1_Par_Ref;
+Arr_2_Dim       Arr_2_Par_Ref;
+int             Int_1_Par_Val;
+int             Int_2_Par_Val;
+{
+  REG One_Fifty Int_Index;
+  REG One_Fifty Int_Loc;
+
+  Int_Loc = Int_1_Par_Val + 5;
+  Arr_1_Par_Ref [Int_Loc] = Int_2_Par_Val;
+  Arr_1_Par_Ref [Int_Loc+1] = Arr_1_Par_Ref [Int_Loc];
+  Arr_1_Par_Ref [Int_Loc+30] = Int_Loc;
+  for (Int_Index = Int_Loc; Int_Index <= Int_Loc+1; ++Int_Index)
+    Arr_2_Par_Ref [Int_Loc] [Int_Index] = Int_Loc;
+  Arr_2_Par_Ref [Int_Loc] [Int_Loc-1] += 1;
+  Arr_2_Par_Ref [Int_Loc+20] [Int_Loc] = Arr_1_Par_Ref [Int_Loc];
+  Int_Glob = 5;
+} /* Proc_8 */
+
+
+Enumeration Func_1 (Ch_1_Par_Val, Ch_2_Par_Val)
+/*************************************************/
+    /* executed three times                                         */
+    /* first call:      Ch_1_Par_Val == 'H', Ch_2_Par_Val == 'R'    */
+    /* second call:     Ch_1_Par_Val == 'A', Ch_2_Par_Val == 'C'    */
+    /* third call:      Ch_1_Par_Val == 'B', Ch_2_Par_Val == 'C'    */
+
+Capital_Letter   Ch_1_Par_Val;
+Capital_Letter   Ch_2_Par_Val;
+{
+  Capital_Letter        Ch_1_Loc;
+  Capital_Letter        Ch_2_Loc;
+
+  Ch_1_Loc = Ch_1_Par_Val;
+  Ch_2_Loc = Ch_1_Loc;
+  if (Ch_2_Loc != Ch_2_Par_Val)
+    /* then, executed */
+    return (Ident_1);
+  else  /* not executed */
+  {
+    Ch_1_Glob = Ch_1_Loc;
+    return (Ident_2);
+   }
+} /* Func_1 */
+
+
+Boolean Func_2 (Str_1_Par_Ref, Str_2_Par_Ref)
+/*************************************************/
+    /* executed once */
+    /* Str_1_Par_Ref == "DHRYSTONE PROGRAM, 1'ST STRING" */
+    /* Str_2_Par_Ref == "DHRYSTONE PROGRAM, 2'ND STRING" */
+
+Str_30  Str_1_Par_Ref;
+Str_30  Str_2_Par_Ref;
+{
+  REG One_Thirty        Int_Loc;
+      Capital_Letter    Ch_Loc ;
+
+  Int_Loc = 2;
+  while (Int_Loc <= 2) /* loop body executed once */
+    if (Func_1 (Str_1_Par_Ref[Int_Loc],
+                Str_2_Par_Ref[Int_Loc+1]) == Ident_1)
+      /* then, executed */
+    {
+      Ch_Loc = 'A';
+      Int_Loc += 1;
+    } /* if, while */
+  if (Ch_Loc >= 'W' && Ch_Loc < 'Z')
+    /* then, not executed */
+    Int_Loc = 7;
+  if (Ch_Loc == 'R')
+    /* then, not executed */
+    return (true);
+  else /* executed */
+  {
+    if (strcmp (Str_1_Par_Ref, Str_2_Par_Ref) > 0)
+      /* then, not executed */
+    {
+      Int_Loc += 7;
+      Int_Glob = Int_Loc;
+      return (true);
+    }
+    else /* executed */
+      return (false);
+  } /* if Ch_Loc */
+} /* Func_2 */
+
+
+Boolean Func_3 (Enum_Par_Val)
+/***************************/
+    /* executed once        */
+    /* Enum_Par_Val == Ident_3 */
+Enumeration Enum_Par_Val;
+{
+  Enumeration Enum_Loc;
+
+  Enum_Loc = Enum_Par_Val;
+  if (Enum_Loc == Ident_3)
+    /* then, executed */
+    return (true);
+  else /* not executed */
+    return (false);
+} /* Func_3 */
Index: /trunk/Softwares/Basic_test/src/c/exec_0.c
===================================================================
--- /trunk/Softwares/Basic_test/src/c/exec_0.c	(revision 88)
+++ /trunk/Softwares/Basic_test/src/c/exec_0.c	(revision 88)
@@ -0,0 +1,32 @@
+#include "bool.h"
+#include "func_test.h"
+
+bool exec_0()
+{
+  bool res = false;
+  
+  printf("<exec_0> \n");
+
+  res = (test_01() &&
+	 test_02() &&
+	 test_03() &&
+	 test_04() &&
+	 test_05() &&
+	 test_06() &&
+	 test_07() &&
+	 test_08() &&
+	 test_09() &&
+	 test_10() &&
+	 test_11() &&
+	 test_12() &&
+	 test_13() &&
+	 1);
+  
+  if (res == false)
+    printf("<exec_0> Ko\n");
+  else
+    printf("<exec_0> Ok\n");
+   
+  return (res);
+}
+
Index: /trunk/Softwares/Basic_test/src/c/exec_1.c
===================================================================
--- /trunk/Softwares/Basic_test/src/c/exec_1.c	(revision 88)
+++ /trunk/Softwares/Basic_test/src/c/exec_1.c	(revision 88)
@@ -0,0 +1,31 @@
+#include "bool.h"
+#include "func_test.h"
+
+bool exec_1()
+{
+  bool res = false;
+
+  printf("<exec_1>\n");
+
+  res = (test_10() &&
+	 test_13() &&
+	 test_12() &&
+	 test_11() &&
+	 test_01() &&
+	 test_02() &&
+	 test_03() &&
+	 test_06() &&
+	 test_07() &&
+	 test_04() &&
+	 test_05() &&
+	 test_08() &&
+	 test_09() &&
+	 1);
+
+  if (res == false)
+    printf("<exec_1> Ko\n");
+  else
+    printf("<exec_1> Ok\n");
+
+  return res;
+}
Index: /trunk/Softwares/Basic_test/src/c/exec_2.c
===================================================================
--- /trunk/Softwares/Basic_test/src/c/exec_2.c	(revision 88)
+++ /trunk/Softwares/Basic_test/src/c/exec_2.c	(revision 88)
@@ -0,0 +1,31 @@
+#include "bool.h"
+#include "func_test.h"
+
+bool exec_2()
+{
+  bool res = false;
+
+  printf("<exec_2>\n");
+  
+  res = (test_07() &&
+	 test_02() &&
+	 test_10() &&
+	 test_01() &&
+	 test_13() &&
+	 test_03() &&
+	 test_12() &&
+	 test_06() &&
+	 test_08() &&
+	 test_04() &&
+	 test_11() &&
+	 test_05() &&
+	 test_09() &&
+	 1);
+
+  if (res == false)
+    printf("<exec_2> Ko\n");
+  else
+    printf("<exec_2> Ok\n");
+
+  return res;
+}
Index: /trunk/Softwares/Basic_test/src/c/exec_3.c
===================================================================
--- /trunk/Softwares/Basic_test/src/c/exec_3.c	(revision 88)
+++ /trunk/Softwares/Basic_test/src/c/exec_3.c	(revision 88)
@@ -0,0 +1,31 @@
+#include "bool.h"
+#include "func_test.h"
+
+bool exec_3()
+{
+  bool res = false;
+
+  printf("<exec_3>\n");
+
+  res = (test_05() &&
+	 test_09() &&
+	 test_01() &&
+	 test_10() &&
+	 test_03() &&
+	 test_12() &&
+	 test_02() &&
+	 test_07() &&
+	 test_13() &&
+	 test_04() &&
+	 test_11() &&
+	 test_08() &&
+	 test_06() &&
+	 1);
+  
+  if (res == false)
+    printf("<exec_3> Ko\n");
+  else
+    printf("<exec_3> Ok\n");
+
+  return res;
+}
Index: /trunk/Softwares/Basic_test/src/c/func_array.c
===================================================================
--- /trunk/Softwares/Basic_test/src/c/func_array.c	(revision 88)
+++ /trunk/Softwares/Basic_test/src/c/func_array.c	(revision 88)
@@ -0,0 +1,136 @@
+#include "func_array.h"
+
+//-----[ Selection_sort ]--------------------------------------------------
+
+void selection_sort  (int array[], int size) 
+{
+  int i, min, j , tmp;
+  for(i = 0 ; i < size - 1 ; i++) 
+    {
+      min = i;
+
+      // Find indice min
+      for(j = i+1 ; j < size ; j++)
+	if(array[j] < array[min])
+	  min = j;
+
+      if(min != i) // find or not.
+	{
+	  tmp        = array[i];
+	  array[i]   = array[min];
+	  array[min] = tmp;
+	}
+    }
+}
+
+//-----[ insertion_sort ]--------------------------------------------------
+void insertion_sort (int array[], int size) 
+{
+  /* Spécifications externes : Tri du tableau t par insertion séquentielle */
+  int i,pos,j,tmp;
+
+  for (i = 1 ; i < size ; i++) 
+    {
+      /* Calcul de la position d'insertion pos : */
+      /* détermine le plus petit indice pos       / 0 <= pos <= i */
+      /* qui vérifie array[pos] >= array[i] */
+      pos = 0;
+      
+      while(array[pos] < array[i]) 
+	pos++;
+      
+      tmp = array[i]; /* Sauvegarde de t[i] */
+ 
+      for(j = i-1 ; j >= pos  ; j--)
+	array[j+1] = array[j]; /* translation de t[pos..i-1] vers t[pos+1..i] */
+      
+      array[pos] = tmp; /* insertion de t[pos] */
+    }
+}
+
+//-----[ QuickSort ]-------------------------------------------------------
+
+// QuickSort
+void quick_sort (int * array, int debut, int fin)
+{
+  int          gauche, droite;
+  int          pivot;
+
+  pivot = array[debut];
+
+  for(gauche = debut, droite = fin; gauche < droite; )
+    {
+      
+      for(;array[droite] > pivot; droite--);
+            
+      if(gauche != droite)
+	{
+	  array[gauche] = array[droite];
+	  array[droite] = pivot;
+	  gauche++;
+	}
+      
+      for(; array[gauche] < pivot; gauche++);
+            
+      if(gauche != droite)
+	{ 
+	  array[droite] = array[gauche];
+	  array[gauche] = pivot;
+	  droite--;
+	}
+    }
+  
+  if(debut < gauche-1) quick_sort(array, debut   , gauche-1);
+  if(fin   > gauche+1) quick_sort(array, gauche+1, fin     );
+}
+
+//-----[ BubbleSort ]------------------------------------------------------
+
+void bubble_sort (int array[], unsigned int size) 
+{
+  int i   = 0; /* Indice de répétition du tri */
+  int j   = 0; /* Variable de boucle */
+  int tmp = 0; /* Variable de stockage temporaire */
+  
+  /* Booléen marquant l'arrêt du tri si le tableau est ordonné */
+  int en_desordre = 1; 
+  
+  /* Boucle de répétition du tri et le test qui
+     arrête le tri dès que le tableau est ordonné */
+  for(i = 0 ; (i < size) && (en_desordre == 1); i++)
+    {  
+      /* Supposons le tableau ordonné */
+      en_desordre = 0;
+      
+                /* Vérification des éléments des places j et j-1 */
+      for(j = 1 ; j < size - i ; j++) 
+	{
+	  /* Si les 2 éléments sont mal triés */
+	  if(array[j] < array[j-1])
+	    {
+	      /* Inversion des 2 éléments */
+	      tmp        = array[j-1];
+	      array[j-1] = array[j];
+	      array[j]   = tmp;
+	      
+	      /* Le tableau n'est toujours pas trié */
+	      en_desordre = 1;
+	    }
+	}
+    }
+}
+
+//-----[ Algo ]------------------------------------------------------------
+
+void array_tri_croissant (int * array, unsigned int size,int algo)
+{
+  switch (algo)
+    {
+    case 0 : bubble_sort    (array,size);     break;
+    case 1 : selection_sort (array,size);     break;
+    case 2 : insertion_sort (array,size);     break;
+    case 3 : quick_sort     (array,0,size-1); break;
+    default : break;
+    }
+}
+
Index: /trunk/Softwares/Basic_test/src/c/func_endianness.c
===================================================================
--- /trunk/Softwares/Basic_test/src/c/func_endianness.c	(revision 88)
+++ /trunk/Softwares/Basic_test/src/c/func_endianness.c	(revision 88)
@@ -0,0 +1,20 @@
+#include <stdio.h>
+#include "func_endianness.h"
+
+bool endianness ()
+{
+  union TestEndian test_endian;
+  
+  test_endian.total = 0xFF;
+  
+  if (test_endian.octets.octet1 == 0xFF) 
+    {
+      printf("Little Endian\n");
+      return LittleEndian;
+    }
+  else 
+    {
+      printf("Big Endian\n");
+      return BigEndian;
+    }
+}
Index: /trunk/Softwares/Basic_test/src/c/func_factoriel.c
===================================================================
--- /trunk/Softwares/Basic_test/src/c/func_factoriel.c	(revision 88)
+++ /trunk/Softwares/Basic_test/src/c/func_factoriel.c	(revision 88)
@@ -0,0 +1,24 @@
+#include "func_factoriel.h"
+#include "func_math.h"
+
+//-----[ Factoriel ]-------------------------------------------------------
+
+unsigned int fact_recursif (unsigned int x)
+{
+  if ( x <= 1)
+    return 1;
+  
+  return (mul_soft (x , fact_recursif (x-1) ) );
+}
+
+unsigned int fact_iteratif (unsigned int x)
+{
+  unsigned int res= 1;
+  
+  while (x > 1)
+    {
+      res = mul_soft(res,x);
+      x --;
+    }
+  return res;
+}
Index: /trunk/Softwares/Basic_test/src/c/func_fibonnacci.c
===================================================================
--- /trunk/Softwares/Basic_test/src/c/func_fibonnacci.c	(revision 88)
+++ /trunk/Softwares/Basic_test/src/c/func_fibonnacci.c	(revision 88)
@@ -0,0 +1,18 @@
+#include "func_fibonnacci.h"
+
+int fibonnacci(int x)
+{
+  int i;
+  int xn   = 0;
+  int xn_1 = 1;
+  int xn_2 = 0;
+
+  for (i=0;i<=x;i++)
+    {
+      xn   = xn_1 + xn_2;
+      xn_2 = xn_1;
+      xn_1 = xn;
+    }
+  
+  return xn;
+}
Index: /trunk/Softwares/Basic_test/src/c/func_hanoi.c
===================================================================
--- /trunk/Softwares/Basic_test/src/c/func_hanoi.c	(revision 88)
+++ /trunk/Softwares/Basic_test/src/c/func_hanoi.c	(revision 88)
@@ -0,0 +1,24 @@
+#include "func_hanoi.h"
+
+int hanoi_recursif(char pic_depart, char pic_destination, char pic_transition, int nb_disques)
+{
+  unsigned int nb_move = 0;
+  
+  if (nb_disques == 1)
+    {
+      nb_move = 1;
+    }
+  else
+    {
+      //on modifie les positions des palets 
+      nb_move += hanoi_recursif(pic_depart     , pic_transition  , pic_destination, nb_disques - 1);
+      nb_move += hanoi_recursif(pic_depart     , pic_destination , pic_transition , 1             );
+      nb_move += hanoi_recursif(pic_transition , pic_destination , pic_depart     , nb_disques - 1);
+    }
+  return nb_move;
+}
+
+int hanoi(int nb_disques)
+{
+  return(hanoi_recursif('1', '2', '3', nb_disques));
+}
Index: /trunk/Softwares/Basic_test/src/c/func_integrity.c
===================================================================
--- /trunk/Softwares/Basic_test/src/c/func_integrity.c	(revision 88)
+++ /trunk/Softwares/Basic_test/src/c/func_integrity.c	(revision 88)
@@ -0,0 +1,60 @@
+#include <stdio.h>
+#include "func_integrity.h"
+#include "func_io.h"
+
+extern bool  asm_001_add          ();
+extern bool  asm_002_addc         ();
+extern bool  asm_003_extend       ();
+extern bool  asm_004_sfeq         ();
+extern bool  asm_005_sfne         ();
+extern bool  asm_006_sfges        ();
+extern bool  asm_007_sfgeu        ();
+extern bool  asm_008_sfgts        ();
+extern bool  asm_009_sfgtu        ();
+extern bool  asm_010_sfles        ();
+extern bool  asm_011_sfleu        ();
+extern bool  asm_012_sflts        ();
+extern bool  asm_013_sfltu        ();
+extern bool  asm_014_cmov         ();
+extern bool  asm_015_shift_rotate ();
+extern bool  asm_016_load         ();
+extern bool  asm_017_mul          ();
+
+bool test_integrity ()
+{
+  bool res;
+
+  res = 
+    asm_001_add          () &&
+    asm_002_addc         () &&
+    asm_003_extend       () &&
+    asm_004_sfeq         () &&
+    asm_005_sfne         () &&
+    asm_006_sfges        () &&
+    asm_007_sfgeu        () &&
+    asm_008_sfgts        () &&
+    asm_009_sfgtu        () &&
+    asm_010_sfles        () &&
+    asm_011_sfleu        () &&
+    asm_012_sflts        () &&
+    asm_013_sfltu        () &&
+    asm_014_cmov         () &&
+    asm_015_shift_rotate () &&
+    asm_016_load         () &&
+    asm_017_mul          () &&
+    1;
+
+  if (res == true)
+    {
+      print(1);
+      printf("<test_integrity> Test is Ok\n");
+    }
+  
+  else
+    {
+      quit(-1);
+      printf("<test_integrity> Test is Ko\n");
+    }
+  
+  return res;
+}
Index: /trunk/Softwares/Basic_test/src/c/func_math.c
===================================================================
--- /trunk/Softwares/Basic_test/src/c/func_math.c	(revision 88)
+++ /trunk/Softwares/Basic_test/src/c/func_math.c	(revision 88)
@@ -0,0 +1,68 @@
+#include "func_math.h"
+
+//-----[ Multiplication ]--------------------------------------------------
+
+// Multiplication rapide
+unsigned int mul_soft(unsigned int op1,
+		      unsigned int op2)
+{
+  unsigned int num_bit,carry;
+  unsigned int op2_aux = op2;
+  unsigned int res     = 0;
+  
+  for(num_bit=0;num_bit<32; num_bit++)
+    {
+      if (op2_aux == 0)
+	break;
+
+      carry   = op2_aux & 1;
+      op2_aux = op2_aux >> 1;
+      
+      if (carry!=0)
+	res += (op1 << num_bit);
+    }
+  return res;
+}
+
+unsigned int mul_hard(unsigned int op1,
+		      unsigned int op2)
+{
+  return op1*op2;
+}
+
+//-----[ Division ]--------------------------------------------------------
+
+unsigned int div_soft( unsigned int op1,
+		       unsigned int op2)
+{
+  unsigned res;
+  
+  if (op2 == 0)
+    return 0;
+  
+  for (res = 0; op1 >= op2; res ++)
+    op1 -= op2;
+  
+  return res;
+}
+
+unsigned int div_hard( unsigned int op1,
+		       unsigned int op2)
+{
+//return (op1/op2);
+  return div_soft(op1,op2);
+}
+
+//-----[ Modulo ]----------------------------------------------------------
+
+unsigned int modulo( unsigned int x,
+		     unsigned int base)
+{
+  if (base==0)
+    return 0;
+  
+  while(x >= base)
+    x -= base;
+  
+  return x;
+}
